c generates param.in, pl.in and tp.in at given time from bin.dat
c modified by Miroslav Broz, miroslav.broz@usa.net, Apr 24th 1998

	include 'swift.inc'
	include 'filter.inc'

	real*8 xht(NTPMAX),yht(NTPMAX),zht(NTPMAX)
	real*8 vxht(NTPMAX),vyht(NTPMAX),vzht(NTPMAX)

	real*8 mass(NPLMAX)
	real*8 xh(NPLMAX),yh(NPLMAX),zh(NPLMAX)
	real*8 vxh(NPLMAX),vyh(NPLMAX),vzh(NPLMAX)

	integer istat(NTPMAX,NSTAT)
        real*8 rstat(NTPMAX,NSTATR)
	integer nbod,ntp,istep
	integer iflgchk,iu,nleft,i,id,iuf

	real*8 t0,tstop,dt,dtout,dtdump,dtfilter
	real*8 t

	real*8 rmin,rmax,rmaxu,qmin,rplsq(NPLMAX)
        logical*2 lclose
        real*8 a,e,inc,capom,omega,capm,j2rp2,j4rp4

        real elmts(-NPLMAX:NTPMAX,6)
        real*8 tget,gm,dtmean

	character*80 outfile,inparfile,inplfile,intpfile,fopenstat,
     &    inthfile,infilterfile,outfilterfile

c Get data for the run and the test particles
	write(*,*) 'Enter name of parameter data file : '
	read(*,999) inparfile
	call io_init_param(inparfile,t0,tstop,dt,dtout,dtdump,
     &         iflgchk,rmin,rmax,rmaxu,qmin,lclose,outfile,fopenstat)

c Prompt and read name of planet data file
	write(*,*) ' '
	write(*,*) 'Enter name of planet data file : '
	read(*,999) inplfile
999 	format(a)
	call io_init_pl(inplfile,lclose,iflgchk,nbod,mass,xh,yh,zh,
     &       vxh,vyh,vzh,rplsq,j2rp2,j4rp4)

c Get data for the run and the test particles
	write(*,*) 'Enter name of test particle data file : '
	read(*,999) intpfile
	call io_init_tp(intpfile,ntp,xht,yht,zht,vxht,vyht,
     &               vzht,istat,rstat)

c Read the thermal data filename ONLY, call io_init_th is not neccesary
	write(*,*) 'Enter name of thermal data file : '
	read(*,999) inthfile

c Prompt and read name of filter parameters file
        write(*,*) 'Enter name of filter parameters file : '
        read(*,999) infilterfile
        call io_init_filter(infilterfile,dtfilter,outfilterfile)

        write(*,*) 'Enter required time in Myr (-1 for the end) : '
        read(*,*) tget
        write(*,*) tget
        write(*,*)
        tget = tget * 365.25d6

        iu = 20
        iuf = 30

        if(btest(iflgchk,0)) then
           write(*,*) ' Reading an integer*2 binary file '
        else if(btest(iflgchk,1)) then
           write(*,*) ' Reading an real*4 binary file '
        else
           write(*,*) ' ERROR: no binary file format specified'
     &       // ' in param file'
           stop
        endif

        open(unit=iu, file=outfile, status='old',form='unformatted')

        if (tget.lt.0) tget = tstop
        dtmean = 0.0d0

100     continue
          call read_data(iu,dtmean,tget,t,nbod,nleft,elmts,istep)
        if ((istep.lt.0).and.(t.lt.tget)) goto 100

        write(*,*) ' Reached time ',t/365.25d6,' Myr (dumped)'

        call io_dump_param('dump_param.dat',t,tstop,dt,dtout,
     &    dtdump,iflgchk,rmin,rmax,rmaxu,qmin,lclose,outfile)
        do i = 2, nbod
          id = -i
          gm = mass(1) + mass(i)
          a = elmts(id,1)
          e = elmts(id,2)
          inc = elmts(id,3)
          capom = elmts(id,4)
          omega = elmts(id,5)
          capm = elmts(id,6)
          call orbel_el2xv(gm,-1,a,e,inc,capom,omega,capm,
     &      xh(i),yh(i),zh(i),vxh(i),vyh(i),vzh(i))
        enddo
        call io_dump_pl('dump_pl.dat',nbod,mass,xh,yh,zh,
     &    vxh,vyh,vzh,lclose,iflgchk,rplsq,j2rp2,j4rp4)
        do i = 1, nleft
          id = i
          gm = mass(1)
          a = elmts(id,1)
          e = elmts(id,2)
          inc = elmts(id,3)
          capom = elmts(id,4)
          omega = elmts(id,5)
          capm = elmts(id,6)
          call orbel_el2xv(gm,-1,a,e,inc,capom,omega,capm,
     &      xht(i),yht(i),zht(i),vxht(i),vyht(i),vzht(i))
        enddo
        call io_dump_tp('dump_tp.dat',nleft,xht,yht,zht,
     &    vxht,vyht,vzht,istat,rstat)

        close(iu)
        stop
        end

c-----------------------------------------------------------------------
      subroutine read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
      include 'swift.inc'
c  input
      integer iuf	! binary file handle
      real*8 dtmean	! required time step, set to 0 to get all data
      real*8 tmean	! recent time, when data were obtained
c  output
      real*8 t		! time read from binary file (to be displayed)
      integer nbod	! number of massive bodies
      integer nleft	! number of test particles
      real elmts(-NPLMAX:NTPMAX,6)	! array of orbital elements
      integer istep	! if flag.eq.0 we are at the end of binary file
c
c  read one record from binary input file into array elmts
c-----------------------------------------------------------------------
      real*8 a,e,inc,capom,omega,capm
      integer ierr,i,id
c  functions
      integer io_read_hdr_r,io_read_line_r

10    continue
      istep = 0
      ierr = io_read_hdr_r(iuf,t,nbod,nleft)
      if (ierr.ne.0) goto 999
        do i=2,nbod
          ierr = io_read_line_r(iuf,id,a,e,inc,capom,omega,capm)
          if (ierr.ne.0) goto 999
          istep = 1
          id=-1*i
          elmts(id,1)=a
          elmts(id,2)=e
          elmts(id,3)=inc
          elmts(id,4)=capom
          elmts(id,5)=omega
          elmts(id,6)=capm
        enddo
        do i=1,nleft
          ierr = io_read_line_r(iuf,id,a,e,inc,capom,omega,capm)
          if (ierr.ne.0) goto 999
          istep = 1
          elmts(id,1)=a
          elmts(id,2)=e
          elmts(id,3)=inc
          elmts(id,4)=capom
          elmts(id,5)=omega
          elmts(id,6)=capm
        enddo
      if (t.lt.tmean) goto 10
999   continue
      return
      end

