c inspect (filter) binary file of mean elements by PGPLOT routines
c in various graphs
c created by Miroslav Broz, miroslav.broz@usa.net, Apr 20th 1999

c-----------------------------------------------------------------------
      program inspect

      include 'swift.inc'
      include 'filter.inc'

      real pi_,rad,deg,arcsec
      parameter(pi_ = 3.1415926535, deg=pi_/180, rad=180/pi_)
      parameter(arcsec = pi/180./3600.)

      real*8 xht(NTPMAX),yht(NTPMAX),zht(NTPMAX)
      real*8 vxht(NTPMAX),vyht(NTPMAX),vzht(NTPMAX)

      real*8 mass(NPLMAX),dr
      real*8 xh(NPLMAX),yh(NPLMAX),zh(NPLMAX)
      real*8 vxh(NPLMAX),vyh(NPLMAX),vzh(NPLMAX)

      integer istat(NTPMAX,NSTAT)
      real*8 rstat(NTPMAX,NSTATR)
      integer nbod,ntp,istep
      integer iflgchk,iu,nleft,id,iuf

      real*8 t0,tstop,dt,dtout,dtdump,dtfilter
      real*8 t,tmax

      real*8 rmin,rmax,rmaxu,qmin,rplsq(NPLMAX)
      logical*2 lclose
      real*8 j2rp2,j4rp4

      character*80 outfile,inparfile,inplfile,intpfile,fopenstat,
     &  inthfile,infilterfile,outfilterfile,infile

c  thermal variables are given to getacch subroutine in common block /yarko/
      integer k_seasonal
      real*8 s(3,NTPMAX),lambda0(NTPMAX),Tstar40(NTPMAX),rho0(NTPMAX),
     &  lambdas0(NTPMAX),Rdash0(NTPMAX)
      complex*8 psi(NTPMAX)
      common/yarko/s,psi,lambda0,Tstar40,rho0,lambdas0,Rdash0,
     &  k_seasonal

      real*8 dtreorient,tau_reor,tau_disr
      integer iseed,pgband
      character c

      integer col_max,imax
      parameter(col_max = 64)
      integer col(col_max)
      character*255 str
      integer i,j,k,m,n,l,pm,pn
      real lambda_id,lambda_planet,lambda_pm,lambda_pn

c  debugging code
      real*8 radius(NTPMAX),thetas(NTPMAX),rhos0(NTPMAX)
      common/debug/radius,thetas,rhos0

      real*8 dtmean,tmean
      real x1,x2,y1,y2,dx,dy,pgwidth,pgaspect
      real elmts(-NPLMAX:NTPMAX,6)
      real elmtstmp(1:NTPMAX)
      character*32 device
      integer length,lng,dev2
      logical*1 lflg,fflg,bflg,nflg
c  colours indices, if(cflg(i).lt.0) then don't display ith particle
      integer cflg(-NPLMAX:NTPMAX)
      character*255 type
      character*255 cflgstr,colsstr,fgbgstr
      integer symbol
      real x,y,x0,y0
      real chsize,tchsize,vminx,vmaxx,vminy,vmaxy
      character*255 titlestr
      integer maxres
      parameter(maxres=100)
      character*80 resstr(maxres)
      real t1,t2
      integer dev,col1,col2,ls1,ls2,lastcflg,nres,i1st
      real ival
      
c  functions
      integer pgopen
      real zero2pi

      character*16 planet(9)
      real g_(5:6)
      real g_1(6:6)

      data planet /'Mercury','Venus','Earth','Mars','Jupiter',
     :  'Saturn','Uran','Neptune','Pluto'/
      data g_ /4.30, 27.77/
      data g_1 /-25.30/
      data elmtstmp /NTPMAX*0.0/

c-----------------------------------------------------------------------

c units of frequences are arcsec/yr
      do i = 5, 6
        g_(i) = g_(i)*arcsec
      enddo
      do i = 6, 6
        g_1(i) = g_1(i)*arcsec
      enddo

c Get data for the run and the test particles
      write(*,*) 'Enter name of parameter data file : '
5     continue
        read(*,10) inparfile
      if (inparfile(1:1).eq.'#') goto 5
     
      call io_init_param(inparfile,t0,tstop,dt,dtout,dtdump,
     &  iflgchk,rmin,rmax,rmaxu,qmin,lclose,outfile,fopenstat)

c Prompt and read name of planet data file
      write(*,*) ' '
      write(*,*) 'Enter name of planet data file : '
      read(*,10) inplfile
10    format(a)
      call io_init_pl(inplfile,lclose,iflgchk,nbod,mass,xh,yh,zh,
     &  vxh,vyh,vzh,rplsq,j2rp2,j4rp4)

c Get data for the run and the test particles
      write(*,*) 'Enter name of test particle data file : '
      read(*,10) intpfile
      call io_init_tp(intpfile,ntp,xht,yht,zht,vxht,vyht,
     &  vzht,istat,rstat)

c Read the thermal data filename, call io_init_th to get R's and zeta's
      write(*,*) 'Enter name of thermal data file : '
      read(*,10) inthfile
      call io_init_th(inthfile,ntp,dtreorient,tau_reor,tau_disr,
     &  iseed,iflgchk)

c Prompt and read name of filter parameters file
      write(*,*) 'Enter name of filter parameters file : '
      read(*,10) infilterfile
      call io_init_filter(infilterfile,dtfilter,outfilterfile)

c Prompt for graphics device/type
      write(*,*) 'Enter device descriptor ([file]/device) : '
      read(*,10) device
      write(*,10) device

c Prompt for width [inch] and aspect of the plot
      write(*,*) 'Enter width [inch] and aspect of the plot : '
      read(*,*) pgwidth,pgaspect
      write(*,*) pgwidth,pgaspect

c Prompt for character sizes
      write(*,*) 'Enter character sizes of labels and title '
     :  //'[1/40 height of plot]: '
      read(*,*) chsize,tchsize
      write(*,*) chsize,tchsize

c Prompt for viewport
      write(*,*) 'Enter x1,x2,y1,y2 of viewport (0,1) : '
      read(*,*) vminx,vmaxx,vminy,vmaxy
      write(*,*) vminx,vmaxx,vminy,vmaxy

c Prompt for backgroung and text colors
      write(*,*) 'Enter color names for background and foreground '
     :  //'(e.g. black white) : '
      read(*,10) fgbgstr
      write(*,10) fgbgstr(1:length(fgbgstr))
      
c Prompt for default marker
      write(*,*) 'Enter index of graph marker (default -1) : '
      read(*,*) symbol
      write(*,*) symbol

c Graph title
      write(*,*) 'Enter graph title : '
      read(*,10) titlestr
      write(*,10) titlestr(1:length(titlestr))

c Prompt for time step [y]
      write(*,*) 'Enter time step [yr] : '
      read(*,*) dtmean
      write(*,*) dtmean
c  dtmean is given in yr
      dtmean = dtmean*365.25d0

c Prompt for type of graph, the string will be analysed later
      write(*,*) 'Enter graph type y(x) :'
      read(*,10) type
      write(*,10) type(1:length(type))

c Prompt for graph ranges
      write(*,*) 'Enter graph ranges (x1,x2,y1,y2) :'
      read(*,*) x1,x2,y1,y2
      write(*,*) x1,x2,y1,y2

c Prompt for active particles
      write(*,*) 'Enter numbers of active particles (e.g. -4:-2 1:5) : '
      read(*,10) cflgstr
      write(*,10) cflgstr(1:length(cflgstr))

c Prompt for color indices or palette filename
      write(*,*) 'Enter corresponding colos indices or names : '
      read(*,10) colsstr
      write(*,10) colsstr(1:length(colsstr))

c Prompt for tracing (T) or clearing (F)
      write(*,*) 'Erase displayed data? [T|F] : '
      read(*,*) lflg
      write(*,*) lflg

c Use (filter) binary file?
      write(*,*) 'Use filter binary file? [T|F] : '
      read(*,*) fflg
      write(*,*) fflg

c Plot borders?
      write(*,*) 'Plot resonance and crossing borders? numbers? '//
     :  'e or sini, line styles, colors, nres : '
      read(*,*) bflg, nflg, ival, ls1, ls2, col1, col2, nres
      write(*,*) bflg, nflg, ival, ls1, ls2, col1, col2, nres

c Read resonance data
      do i = 1, nres
        read(*,10) resstr(i)
      enddo
 
c
c  open graphical device for most of graph types
c
      if (index(type,'(a,e)(t)').eq.0) then
        if (pgopen(device).le.0) stop
      endif
c
c  open binary input file
c
      iu = 20
      iuf = 30

      dr = 180.0/PI

      if(btest(iflgchk,0)) then
         write(*,*) ' Reading an integer*2 binary file '
      else if(btest(iflgchk,1)) then
         write(*,*) ' Reading an real*4 binary file '
      else
         write(*,*) ' ERROR: no binary file format specified '
         write(*,*) '        in param file '
         stop
      endif

      if (fflg) then
        infile = outfilterfile
      else
        infile = outfile
      endif
c
c  repeat from here, if zoom required
c
15    continue

      if (index(type,'(a,e)(t)').eq.0) then
      call pgqinf('type',device,lng)
c
c  decode and color palette for planets and test bodies
c
      if (colsstr(1:1).eq.'@') then
c
c  2DO: read in palette file
c
      else
        call getcol(colsstr,col,imax)
        call getcol2(cflgstr,col,imax,cflg)
      endif
      call fgbgset(fgbgstr)
c
c  initialization of graphic device
c
      call pgask(.false.)
      call pgpap(pgwidth,pgaspect)
      call pgsvp(vminx,vmaxx,vminy,vmaxy)
      call pgsch(chsize)
      call pgswin(x1,x2,y1,y2,1.0,0,1)
      call pgsci(1)
      call pgtbox('BCNST1',0.0,0,'BCNST1',0.0,0)
      call pgqchs(dx,dy)
      endif
c
c  open binary file
c
      open(unit=iuf, file=infile,status='old',form='unformatted')

      tmax = 0.0 
      tmean = 0.0      ! initial dump
c
c  decide on type of graph - (a,e)
c
      if (index(type,'e(a)').gt.0) then
        if (fflg) then
          call pglab('mean a [AU]','mean e []', titlestr)
        else
          call pglab('a [AU]','e []', titlestr)
        endif
        if (symbol.lt.-31) then
          call pgslw(-symbol-30)
          symbol = -1
        endif
20      continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          do i=2,nbod
            id = -i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(elmts(id,1),elmts(id,2),symbol)
            endif
          enddo
          do i=1,ntp
            id = i
            if (cflg(id).gt.0) then
              if (cflg(id).ne.lastcflg) then
                call pgsci(cflg(id))
                lastcflg = cflg(id)
              endif
              call pgpt1(elmts(id,1),elmts(id,2),symbol)
            endif
          enddo
        goto 20
c
c  decide on type of graph - a(e)
c
      elseif (index(type,'a(e)').gt.0) then
        if (fflg) then
          call pglab('mean e []','mean a [AU]', titlestr)
        else
          call pglab('e []','a [AU]', titlestr)
        endif
        if (symbol.lt.-31) then
          call pgslw(-symbol-30)
          symbol = -1
        endif
        if (bflg) then
          call resonance_at(x1,x2,y1,y2,nres,resstr,ls1,col1)
        endif
        t1 = 0.
190     continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          do i=2,nbod
            id = -i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(elmts(id,2),elmts(id,1),symbol)
            endif
          enddo
          do i=1,ntp
            id = i
            if (cflg(id).gt.0) then
              if (cflg(id).ne.lastcflg) then
                call pgsci(cflg(id))
                lastcflg = cflg(id)
              endif
              call pgpt1(elmts(id,2),elmts(id,1),symbol)
            endif
          enddo
        goto 190
c
c  sini(a)
c
      elseif (index(type,'sini(a)').gt.0) then
        if (fflg) then
          call pglab('mean a [AU]', 'mean sin(i) []', titlestr)
        else
          call pglab('a [AU]', 'sin(i) []', titlestr)
        endif
30      continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          do i=2,nbod
            id = -i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(elmts(id,1),sin(elmts(id,3)),symbol)
            endif
          enddo
          do i=1,ntp
            id = i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(elmts(id,1),sin(elmts(id,3)),symbol)
            endif
          enddo
        goto 30
c
c  decide - a(sini)
c
      elseif (index(type,'a(sini)').gt.0) then
        if (fflg) then
          call pglab('mean sin(i) []','mean a [AU]', titlestr)
        else
          call pglab('sin(i) []','a [AU]', titlestr)
        endif
        if (symbol.lt.-31) then
          call pgslw(-symbol-30)
          symbol = -1
        endif
        if (bflg) then
          call resonance_at(x1,x2,y1,y2,nres,resstr,ls1,col1)
        endif
        t1 = 0.
200     continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          do i=2,nbod
            id = -i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(sin(elmts(id,3)),elmts(id,1),symbol)
            endif
          enddo
          do i=1,ntp
            id = i
            if (cflg(id).gt.0) then
              if (cflg(id).ne.lastcflg) then
                call pgsci(cflg(id))
                lastcflg = cflg(id)
              endif
              call pgpt1(sin(elmts(id,3)),elmts(id,1),symbol)
            endif
          enddo
        goto 200
c
c  a(t)
c
      elseif (index(type,'a(t)').gt.0) then
        if (fflg) then
          call pglab('t [Myr]','mean a [AU]',titlestr)
        else
          call pglab('t [Myr]','a [AU]',titlestr)
        endif
        if (symbol.lt.-31) then
          call pgslw(-symbol-30)
          symbol = -1
        endif
        if (bflg) then
          call resonance_at(x1,x2,y1,y2,nres,resstr,ls1,col1)
        endif
        i1st = 0
210     continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          x = t/365.25e6
          if (x.lt.x1) goto 210
          if (x.gt.x2) goto 900
          do i=2,nbod
            id = -i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(x,elmts(id,1),symbol)
            endif
          enddo
          do i=1,ntp
            id = i
            if (abs(elmts(id,1)-elmtstmp(id)).gt.1e-6) then
            if (cflg(id).gt.0) then
              if (cflg(id).ne.lastcflg) then
                call pgsci(cflg(id))
                lastcflg = cflg(id)
              endif
              call pgpt1(x,elmts(id,1),symbol)
            endif
            elmtstmp(id) = elmts(id,1)
            endif
          enddo

          if ((nflg).and.(i1st.eq.0)) then
            if (x.gt.ival) then
              i1st = 1
              call pgsci(1)
              do i=1,ntp
                id = i
                if (cflg(id).gt.0) then
                  write(str,*) id
                  call pgptxt(x,elmts(id,1),0.0,0.0,
     :              str(1:length(str)))
                endif
              enddo
              lastcflg=-1
            endif
          endif
        goto 210
c
c  q(t)
c
      elseif (index(type,'q(t)').gt.0) then
        if (fflg) then
          call pglab('t [Myr]','mean q [AU]',titlestr)
        else
          call pglab('t [Myr]','q [AU]',titlestr)
        endif
        if (symbol.lt.-31) then
          call pgslw(-symbol-30)
          symbol = -1
        endif
40      continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          x = t/365.25e6
          if (x.lt.x1) goto 40
          if (x.gt.x2) goto 900
          do i=2,nbod
            id = -i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(x,elmts(id,1)*(1.-elmts(id,2)),symbol)
            endif
          enddo
          do i=1,ntp
            id = i
            if (abs(elmts(id,1)-elmtstmp(id)).gt.1e-6) then
            if (cflg(id).gt.0) then
              if (cflg(id).ne.lastcflg) then
                call pgsci(cflg(id))
                lastcflg = cflg(id)
              endif
              call pgpt1(x,elmts(id,1)*(1.-elmts(id,2)),symbol)
            endif
            elmtstmp(id) = elmts(id,1)
            endif
          enddo
        goto 40
c
c  e(t)
c
      elseif ((index(type,'e(t)').gt.0).and.
     :  (index(type,'node(t)').eq.0)) then
        if (fflg) then
          call pglab('t [Myr]','mean e []',titlestr)
        else
          call pglab('t [Myr]','e []',titlestr)
        endif
50      continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          x = t/365.25e6
          if (x.gt.x2) goto 900
          do i=2,nbod
            id = -i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(x,elmts(id,2),symbol)
            endif
          enddo
          do i=1,ntp
            id = i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(x,elmts(id,2),symbol)
            endif
          enddo
        goto 50
c
c  sini(t)
c
      elseif ((index(type,'sini(t)').gt.0).and.
     :  (index(type,'peri(t)').eq.0)) then
        if (fflg) then
          call pglab('t [Myr]','mean sin(i) []',titlestr)
        else
          call pglab('t [Myr]','sin(i) []',titlestr)
        endif
60      continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          x = t/365.25e6
          if (x.gt.x2) goto 900
          do i=2,nbod
            id = -i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(x,sin(elmts(id,3)),symbol)
            endif
          enddo
          do i=1,ntp
            id = i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(x,sin(elmts(id,3)),symbol)
            endif
          enddo
        goto 60
c
c  peri(t)
c
      elseif (index(type,'peri(t)').gt.0) then
        call pglab('t [Myr]','peri [deg]',titlestr)
70      continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          x = t/365.25e6
          if (x.gt.x2) goto 900
          do i=2,nbod
            id = -i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(x,zero2pi(elmts(id,4))*rad,symbol)
            endif
          enddo
          do i=1,ntp
            id = i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(x,zero2pi(elmts(id,4))*rad,symbol)
            endif
          enddo
        goto 70
c
c  node(t)
c
      elseif (index(type,'node(t)').gt.0) then
        call pglab('t [Myr]','node [deg]',titlestr)
80      continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          x = t/365.25e6
          if (x.gt.x2) goto 900
          do i=2,nbod
            id = -i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(x,zero2pi(elmts(id,5))*rad,symbol)
            endif
          enddo
          do i=1,ntp
            id = i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(x,zero2pi(elmts(id,5))*rad,symbol)
            endif
          enddo
        goto 80
c
c  i(t)
c
      elseif ((index(type,'i(t)').gt.0)
     &  .and.(index(type,'sini(t)').eq.0)) then
        call pglab('t [Myr]','i [deg]',titlestr)
90      continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          x = t/365.25e6
          if (x.gt.x2) goto 900
          do i=2,nbod
            id = -i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(x,real(elmts(id,3)*degrad),symbol)
            endif
          enddo
          do i=1,ntp
            id = i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(x,real(elmts(id,3)*degrad),symbol)
            endif
          enddo
        goto 90
c
c  a(R)
c
      elseif (index(type,'a(R)').gt.0) then
        call pgpap(pgwidth,pgaspect)
        call pgsvp(vminx,vmaxx,vminy,vmaxy)
        call pgsch(chsize)
        call pgswin(log10(x1),log10(x2),y1,y2,1.0,0,1)
        call pgtbox('BCNST1L',0.0,0,'BCNST1',0.0,0)
        call pglab('R [m]','a [AU]',titlestr)
100     continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          do i=1,ntp
            id = i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(real(log10(radius(id))),elmts(id,1),symbol)
            endif
          enddo
        goto 100
c
c  da/dt(R)
c
      elseif (index(type,'da/dt(R)').gt.0) then
        call pgpap(pgwidth,pgaspect)
        call pgsvp(vminx,vmaxx,vminy,vmaxy)
        call pgsch(chsize)
        call pgswin(log10(x1),log10(x2),y1,y2,1.0,0,1)
        call pgtbox('BCNST1L',0.0,0,'BCNST1',0.0,0)
        call pglab('R [m]','da/dt [AU/Myr]',titlestr)
110     continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          do i=1,ntp
            id = i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(real(log10(radius(id))),elmts(id,1),symbol)
            endif
          enddo
        goto 110
c
c  nu(t) number
c
      elseif (index(type,'nu(t)').gt.0) then
        i = index(type,' ')
        read(type(i:length(type)),*,end=900,err=900) j
        write(str,135) planet(j)(1:length(planet(j))),j
135     format(a,'nu_',i1,' [deg]')
        call pglab('t [Myr]',str(1:length(str)),titlestr)
130     continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          x = t/365.25e6
          if (x.gt.x2) goto 900
          do i = 1, ntp
            id = i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(x,zero2pi(elmts(id,4)+elmts(id,5)-
     :          g_(j)*real(t)/365.25e0)*rad,symbol)
            endif
          enddo
        goto 130
c
c  nu1(t) number
c
      elseif (index(type,'nu6a(t)').gt.0) then
        call pglab('t [Myr]','nu1 analytic [deg]',titlestr)
140     continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          x = t/365.25e6
          if (x.gt.x2) goto 900
          do i=1,ntp
            id = i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(x,zero2pi(elmts(id,4))*rad,symbol)
            endif
          enddo
        goto 140
c
c  mm(t) planet n m (mean motion resonance critical angle)
c
      elseif (index(type,'mm(t)').gt.0) then
        i = index(type,' ')
        read(type(i:length(type)),*,end=900,err=900) j,n,m
        if ((nbod.eq.5).or.(nbod.eq.6)) then
          k = j + 3
        else
          k = j - 1
        endif
        write(str,125) planet(k)(1:length(planet(k))),n,m
125     format(a,' ',i1,':',i1,' [deg]')
        call pglab('t [Myr]',str(1:length(str)),titlestr)
120     continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          x = t/365.25e6
          if (x.gt.x2) goto 900
          do i = 1,ntp
            id = i
            if (cflg(id).gt.0) then
              lambda_id = elmts(id,4)+elmts(id,5)+elmts(id,6)
              lambda_planet = elmts(-j,4)+elmts(-j,5)+elmts(-j,6)
              call pgsci(cflg(id))
              call pgpt1(x,zero2pi(m*lambda_id-n*lambda_planet)*rad,
     :          symbol)
            endif
          enddo
        goto 120
c
c  mmm(t) planeta planetb a b c (mixed mean motion resonance critical angle)
c
      elseif (index(type,'mmm(t)').gt.0) then
        i = index(type,' ')
        read(type(i:length(type)),*,end=900,err=900) pm,pn,m,n,l
        if ((nbod.eq.5).or.(nbod.eq.6)) then
          j = pm + 3
          k = pn + 3
        else
          j = pm - 1
          k = pn - 1
        endif
        write(str,155) planet(j)(1:length(planet(j))),
     :    planet(k)(1:length(planet(k))),m,n,l
155     format(a,'-',a,' ',i2,':',i2,':',i2,' [deg]')
        call pglab('t [Myr]',str(1:length(str)),titlestr)
150     continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          x = t/365.25e6
          if (x.gt.x2) goto 900
          do i = 1,ntp
            id = i
            if (cflg(id).gt.0) then
              lambda_id = elmts(id,4)+elmts(id,5)+elmts(id,6)
              lambda_pm = elmts(-pm,4)+elmts(-pm,5)+elmts(-pm,6)
              lambda_pn = elmts(-pn,4)+elmts(-pn,5)+elmts(-pn,6)
              call pgsci(cflg(id))
              call pgpt1(x,zero2pi(m*lambda_pm + n*lambda_pn
     :          + l*lambda_id)*rad,symbol)
            endif
          enddo
        goto 150
c
c  series of (a,e) in given times, resonance borders, crossing borders
c
      elseif (index(type,'(a,e)(t)').gt.0) then
        i = index(type,' ')
        read(type(i:length(type)),*,end=900,err=900) t1,t2
        k = 0
160     continue
          call read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
          if (istep.eq.0) goto 900
          x = t/365.25e6
          if (x.lt.t1) goto 160
c  determine filename and open device
          write(str,170) k
170       format(i3)
          do j = 1, 3
            if (str(j:j).eq.' ') str(j:j)='0'
          enddo
          j = index(device,'*')
          if (j.eq.0) then
            write(*,180)
180         format('Device must have * for multiple images.')
            goto 900
          endif
          str = device(1:j-1)//str(1:3)//device(j+1:length(device))
          dev = pgopen(str)
          if (dev.le.0) then
            write(*,175) str(1:length(str))
175         format('Error opening device ',a)
            goto 900
          endif
          call pgpap(pgwidth,pgaspect)
          call pgask(.false.)
          call getcol(colsstr,col,imax)
          call getcol2(cflgstr,col,imax,cflg)
          call fgbgset(fgbgstr)
          call pgsvp(vminx,vmaxx,vminy,vmaxy)
          call pgsch(chsize)
          call pgswin(x1,x2,y1,y2,1.0,0,1)
          call pgtbox('BCNST1',0.0,0,'BCNST1',0.0,0)
c  determine title
          write(str,165) x
165       format(f6.2)
          call pglab('a [AU]', 'e []', titlestr(1:length(titlestr)) //
     :      ' t = '//str(1:length(str))//' Myr')
          if (bflg) then
            call resonance_borders('e',ival,x1,x2,y1,y2,ls1,col1)
            call crossing_borders(x1,x2,y1,y2,ls2,col2)
            call resonance_labels('e',ival,x1,x2,y1,y2,ls1,col1)
          endif
          if (symbol.lt.-31) then
            call pgslw(-symbol-30)
            symbol = -1
          endif
          do i=2,nbod
            id = -i
            if (cflg(id).gt.0) then
              call pgsci(cflg(id))
              call pgpt1(elmts(id,1),elmts(id,2),symbol)
            endif
          enddo
          if (nflg) then
            call pgsci(1)
            do i=1,ntp
              id = i
              if ((elmts(id,1).gt.x1).and.(elmts(id,1).lt.x2)) then
                if (abs(elmts(id,1)-elmtstmp(id)).gt.1e-6) then
                  if (cflg(id).gt.0) then
                    write(str,*) id
                    call pgptxt(elmts(id,1),elmts(id,2),0.0,0.0,
     :                str(1:length(str)))
                  endif
                endif
              endif
            enddo
          endif
          do i=1,ntp
            id = i
            if ((elmts(id,1).gt.x1).and.(elmts(id,1).lt.x2)
     :        .and.(elmts(id,2).gt.y1).and.(elmts(id,2).lt.y2)) then
              if (abs(elmts(id,1)-elmtstmp(id)).gt.1e-6) then
                if (cflg(id).gt.0) then
                  call pgsci(cflg(id))
                  call pgpt1(elmts(id,1),elmts(id,2),symbol)
                endif
                elmtstmp(id) = elmts(id,1)
              endif
            endif
          enddo
          call pgclos
          t1 = t1 + dtmean/365.25e6
          if (t1.gt.t2) goto 900
          k = k + 1
        goto 160
      else
        write(*,500) type(1:length(type))
500     format('No such type of graph: ',a)
        goto 999
      endif
c
c  write final message and exit
c

900   continue

      write(*,990) t/365.25d6, dtmean/365.25d3
990   format(' tmax = ',f5.2,' Myr, dt = ',f5.2,' kyr')

      if (device.eq.'XWINDOW') then
        j = pgband(0,0,x,y,x,y,c)
c
c  zoom function
c
        if (c.eq.'z') then
          call pgsci(1)
          j = pgband(0,0,x,y,x,y,c)
          j = pgband(2,0,x,y,x0,y0,c)
          x1 = min(x,x0)
          x2 = max(x,x0)
          y1 = min(y,y0)
          y2 = max(y,y0)
          goto 15
c
c  export GIF/PostScript
c
        elseif (c.eq.'e') then
          dev2 = pgopen('./i.ps/cps')
          if (dev2.gt.0) then
            call pgslct(dev2)
	    close(iuf)
            goto 15
          endif
        elseif (c.eq.'g') then
          dev2 = pgopen('./i.gif/gif')
          if (dev2.gt.0) then
            call pgslct(dev2)
	    close(iuf)
            goto 15
          endif
        endif
      endif

999   continue
      close(iuf)
      if (index(type,'(a,e)(t)').eq.0) then
        call pgclos
      endif

      stop
      end

c-----------------------------------------------------------------------
      subroutine read_data(iuf,dtmean,tmean,t,nbod,nleft,elmts,istep)
      include 'swift.inc'
c  input
      integer iuf	! binary file handle
      real*8 dtmean	! required time step, set to 0 to get all data
      real*8 tmean	! recent time, when data were obtained
c  output
      real*8 t		! time read from binary file (to be displayed)
      integer nbod	! number of massive bodies
      integer nleft	! number of test particles
      real elmts(-NPLMAX:NTPMAX,6)	! array of orbital elements
      integer istep	! if flag.eq.0 we are at the end of binary file
c
c  read one record from binary input file into array elmts
c-----------------------------------------------------------------------
      real*8 a,e,inc,capom,omega,capm
      integer ierr,i,id
c  functions
      integer io_read_hdr_r,io_read_line_r

10    continue
      istep = 0
      ierr = io_read_hdr_r(iuf,t,nbod,nleft)
      if (ierr.ne.0) goto 999
      if (t.lt.tmean) then      ! read only and forget
        do i=2,nbod
          ierr = io_read_line_r(iuf,id,a,e,inc,capom,omega,capm)
          if (ierr.ne.0) goto 999
          istep = 1
        enddo
        do i=1,nleft
          ierr = io_read_line_r(iuf,id,a,e,inc,capom,omega,capm)
          if (ierr.ne.0) goto 999
          istep = 1
        enddo
        goto 10
      else      ! read & display
        tmean=tmean+dtmean
        do i=2,nbod
          ierr = io_read_line_r(iuf,id,a,e,inc,capom,omega,capm)
          if (ierr.ne.0) goto 999
          istep = 1
          id=-1*i
          elmts(id,1)=a
          elmts(id,2)=e
          elmts(id,3)=inc
          elmts(id,4)=capom
          elmts(id,5)=omega
          elmts(id,6)=capm
        enddo
        do i=1,nleft
          ierr = io_read_line_r(iuf,id,a,e,inc,capom,omega,capm)
          if (ierr.ne.0) goto 999
          istep = 1
          elmts(id,1)=a
          elmts(id,2)=e
          elmts(id,3)=inc
          elmts(id,4)=capom
          elmts(id,5)=omega
          elmts(id,6)=capm
        enddo
      endif
999   continue
      return
      end

c-----------------------------------------------------------------------
      subroutine resonance_borders(str,ival,x1,x2,y1,y2,ls,col)
      character*(*) str
      real ival
      real x1,x2,y1,y2
      integer ls,col
c
c resonance borders
c-----------------------------------------------------------------------
      real rnu6,r3_1a,r3_1b,r5_2
      external rnu6,r3_1a,r3_1b,r5_2

      call pgsls(ls)
      call pgsci(col)
      if (str(1:1).eq.'e') then
        call pgmove(rnu6(ival),y1)
        call pgdraw(rnu6(ival),y2)
      else
        call pgfuny(rnu6,64,0.0,1.0,1)
      endif
      call pgfuny(r3_1a,64,0.0,1.0,1)
      call pgfuny(r3_1b,64,0.0,1.0,1)
      call pgfuny(r5_2,64,0.0,1.0,1)
      call pgsls(1)
      call pgsci(1)
      return
      end

c-----------------------------------------------------------------------
      subroutine resonance_labels(str,ival,x1,x2,y1,y2,ls,col)
      character*(*) str
      real ival
      real x1,x2,y1,y2
      integer ls,col
c
c resonance labels
c-----------------------------------------------------------------------
      real rnu6,r3_1a,r3_1b,r5_2
      external rnu6,r3_1a,r3_1b,r5_2

      call pgsci(0)
      call pgstbg(col)
      if (str(1:1).eq.'e') then
        call pgmtxt('T',-1.5,(rnu6(ival)-x1)/(x2-x1),0.5,'nu6')
      else
        call label(x1,x2,y1,y2,rnu6,col,'nu6')
      endif
      call label(x1,x2,y1,y2,r3_1a,col,'3:1')
      call label(x1,x2,y1,y2,r3_1b,col,'3:1')
      call label(x1,x2,y1,y2,r5_2,col,'5:2')
      call pgsls(1)
      call pgsci(1)
      return
      end

c-----------------------------------------------------------------------
      real function rnu6(sini)
      real sini
      rnu6=2.1+6.003*abs(sini)**2.256
      return
      end

c-----------------------------------------------------------------------
      real function r3_1a(e)
      real e 
      r3_1a=2.497-(e/8.85)
      return
      end

c-----------------------------------------------------------------------
      real function r3_1b(e)
      real e 
      r3_1b=2.51+(e/9.615)
      return
      end

c-----------------------------------------------------------------------
      real function r5_2(e)
      real e
      r5_2=2.815-0.1*(e-0.15)
      return
      end

c-----------------------------------------------------------------------
      subroutine pgqchs(dx,dy)
c  query actual 'H' character size in world coordinates
      real dx,dy
c-----------------------------------------------------------------------
      real boxx(4),boxy(4)
      call pgqtxt(0.0,0.0,0.0,0.0,'H',boxx,boxy)
      dy=boxy(2)-boxy(1)
      dx=boxx(3)-boxx(1)
      return
      end

c-----------------------------------------------------------------------
      subroutine getcol(colstr,col,max)
c
c  decode string and decide on colors
c
      integer col_max,max
      parameter(col_max = 64)
      character*(*) colstr
      integer col(col_max)
c-----------------------------------------------------------------------
      integer i,j,k
      character*16 strings(col_max)
      integer split

      i = col_max
      max = split(colstr,' ',strings,i)
      j = 15    ! save first 15 idices

      do i = 1, max
        read(strings(i),*,err=10,end=10) col(i)
        goto 20
10        continue
          j = j + 1
          col(i) = j
          call pgscrn(j,strings(i),k)
          if (k.eq.1) then
            col(i) = 1  ! default color
          endif
20      continue
      enddo

      return
      end

c-----------------------------------------------------------------------
      subroutine getcol2(cflgstr,col,maxc,cflg)
c
c  decode string and decide on colors
c
      include 'swift.inc'
      integer col_max,maxc
      parameter(col_max = 64)
      character*(*) cflgstr
      integer col(col_max)
      integer cflg(-NPLMAX:NTPMAX)
c-----------------------------------------------------------------------

      integer i,j,k,a,b,c
      character*16 strings(col_max)
      integer split,length

c  fill the array with default color
      do i = -NPLMAX, NTPMAX
        cflg(i) = -1
      enddo

      i = col_max
      c = split(cflgstr,' ',strings,i)

      j = 0
      do i = 1, c
        k = index(strings(i),':')
        if (k.gt.0) then	! range specified
          read(strings(i)(1:k-1),*,err=99,end=99) a
          read(strings(i)(k+1:length(strings(i))),*,err=99,end=99) b
          do j = a, b
            cflg(j) = col(i)
          enddo
        else			! only 1 body
          read(strings(i),*,err=99,end=99) a
          cflg(a) = col(i)
        endif
      enddo

99    continue      

      return
      end

c-----------------------------------------------------------------------
      real function zero2pi(x)
      real x
c
c  <0,2pi) truncation
c-----------------------------------------------------------------------

      real y,pi2
      parameter(pi2=6.283185307)
      y=(x/pi2-aint(x/pi2))*pi2
      if (y.lt.0d0) y=y+pi2
      zero2pi=y
      return
      end

c-----------------------------------------------------------------------
      subroutine fgbgset(str)
      character*(*) str
c
c  set foreground and background by name
c-----------------------------------------------------------------------
      integer i,j
      character*16 strings(2)
      integer split

      i = 2
      j = split(str,' ',strings,i)
      call pgscrn(0,strings(1),i)
      call pgscrn(1,strings(2),i)
      
      return
      end

c-----------------------------------------------------------------------
      subroutine crossing_borders(x1,x2,y1,y2,ls,col)
      real x1,x2,y1,y2
      integer ls,col
c
c crossing borders
c-----------------------------------------------------------------------
      real peri,aphe
      external peri,aphe
      common /periaphe/ q

      call pgsls(ls)
      call pgsci(col)
      q = 1.*(1.+0.05)
      call pgfuny(peri,64,y1,y2,1)
      call label(x1,x2,y1,y2,peri,col,'Earth (q)')
      q = 1.52*(1.+0.12)
      call pgfuny(peri,64,y1,y2,1)
      call label(x1,x2,y1,y2,peri,col,'Mars (q)')
      q = 5.2*(1.-0.06)
      call pgfuny(aphe,64,y1,y2,1)
      call label(x1,x2,y1,y2,aphe,col,'Jupiter (Q)')
      call pgsls(1)
      call pgsci(1)
      return
      end

c-----------------------------------------------------------------------
      real function peri(e)
      real e,q
      common /periaphe/ q
c-----------------------------------------------------------------------
      peri = q/(1.-e)
      return
      end

c-----------------------------------------------------------------------
      real function aphe(e)
      real e,q
      common /periaphe/ q
c-----------------------------------------------------------------------
      aphe = q/(1.+e)
      return
      end

c-----------------------------------------------------------------------
      subroutine label(x1,x2,y1,y2,fy,col,str)
      implicit none
      real x1,x2,y1,y2
      real fy
      external fy
      integer col
      character*(*) str
c-----------------------------------------------------------------------
      integer oldcol,length
      real binroot2,y

      call pgstbg(col)
      call pgqci(oldcol)
      call pgsci(0)
      if ((fy(y2).gt.x1).and.(fy(y2).lt.x2)) then
        call pgmtxt('T',-1.5,(fy(y2)-x1)/(x2-x1),0.5,str(1:length(str)))
      elseif ((fy(y1).gt.x1).and.(fy(y1).lt.x2)) then
        call pgmtxt('B',-1.5,(fy(y1)-x1)/(x2-x1),0.5,str(1:length(str)))
      else
        y = real(binroot2(fy,y1,y2,x2))
        if ((y.gt.y1+1.e-6).and.(y.lt.y2-1.e-6)) then
          call pgmtxt('RV',-1.0,(y-y1)/(y2-y1),1.0,str(1:length(str)))
        endif
      endif

      call pgstbg(0)
      call pgsci(oldcol)
      return
      end

c----------------------------------------------------------------------
      real function binroot2(f,min,max,y0)
c
c  find root of the function by interval division method
c
c  input:
c  f            external user supplied function
c  min,max      interval
c  y0		zero level, we look for f = y0
c
c  output:
c  binroot2	root of the function f
c
      implicit none
      external f
      real f,min,max,y0
c-----------------------------------------------------------------------
      real eps,x0,x1,x2
      parameter(eps = 1.0d-6)   ! precision

      x0 = min
      x2 = max

10    continue
        x1 = (x2 + x0)/2.0d0
        if ((f(x0)-y0)*(f(x1)-y0).lt.0) then
          x2 = x1
        else
          x0 = x1
        endif
      if (abs(x2-x0).gt.eps) goto 10

      binroot2 = (x2 + x0)/2.0d0

      return
      end

      subroutine pglab(sx,sy,st)
      character*(*) sx,sy,st

      call pgmtxt('B',2.5,0.5,0.5,sx)
      call pgmtxt('L',2.5,0.5,0.5,sy)
      call pgmtxt('T',1.0,0.5,0.5,st)

      return
      end

c-----------------------------------------------------------------------
      subroutine resonance_at(x1,x2,y1,y2,nres,resstr,ls,col)

      implicit none
      real x1,x2,y1,y2
      integer maxres
      parameter(maxres=100)
      character*80 resstr(maxres)
      integer nres,ls,col
c-----------------------------------------------------------------------
      integer i,j,k,l,m
      integer maxstr
      parameter(maxstr=16)
      real a(maxstr),n(maxstr),na,aa,apl(maxstr)
      character*80 str1(maxstr),str2(maxstr)
      character*255 str
      character getpl,strpl(maxstr)
      integer split,length

      call pgsls(ls)
      if (nres.gt.0) write(*,*) 'List of resonances:'
      i = 0
      l = 0
20    do while ((i.lt.nres).and.(i.lt.maxres))
        i = i + 1
        if (resstr(i)(1:1).eq.'#') goto 20
        k = maxstr
        j = split(resstr(i),' ',str1,k)
        if (index(resstr(i),':').eq.0) then
          l = l + 1
          strpl(l)=str1(1)
          read(str1(2),*,end=100,err=100) apl(l)
          goto 20
        endif
        k = maxstr
        j = split(str1(1),':',str2,k)
        do k = 1, j
          read(str2(k),*,end=100,err=100) n(k)
        enddo
        do k = 1, j-1
          if (length(str1(k+1)).gt.1) then
            read(str1(k+1),*,end=100,err=100) a(k)
          else
            do m = 1, l
              if (str1(k+1)(1:1).eq.strpl(m)) a(k)=apl(m)
            enddo
          endif
        enddo
        na = 0.
        do k = 1, j-1
          na = na + a(k)**(-1.5)*n(k)
        enddo
        if (j.gt.2) na = -na
        aa = (na/n(j))**(-2./3.)
        call pgsci(col)
        call pgmove(x1,aa)
        call pgdraw(x2,aa)
        if ((aa.gt.y1).and.(aa.lt.y2)) then
          call pgsci(0)
          call pgstbg(col)
          if (j.eq.2) then
            str = getpl(a(1)) // str2(1)(1:length(str2(1))) // '/' //
     :        str2(2)(1:length(str2(2)))
          else
            if ((index(str2(2),'-').eq.0).and.
     :        (index(str2(2),'+').eq.0))  str2(2) = '+' // str2(2)
            if ((index(str2(3),'-').eq.0).and.
     :        (index(str2(3),'+').eq.0))  str2(3) = '+' // str2(3)
            str = str2(1)(1:length(str2(1))) // getpl(a(1)) //
     :        str2(2)(1:length(str2(2))) // getpl(a(2)) //
     :        str2(3)(1:length(str2(3)))
          endif
          write(*,10) str(1:length(str)),aa
10        format(a10,' --> ',f8.5)
          call pgmtxt('RV',-1.0,(aa-y1)/(y2-y1),1.0,
     :      str(1:length(str)))
        endif
      enddo

      call pgstbg(0)
      call pgsci(1)
      call pgsls(1)
100   continue      
      return
      end

c-----------------------------------------------------------------------
      character function getpl(a)
      implicit none
      real a
c-----------------------------------------------------------------------
      real eps
      parameter(eps=1e-1)

      if (abs(a-1.52).lt.eps) then
        getpl='M'
      elseif (abs(a-5.2).lt.eps) then
        getpl='J'
      elseif (abs(a-9.5).lt.eps) then
        getpl='S'
      else
        getpl=' '
      endif

      return
      end

